×

如何将自己的项目添加Pod

96
黄鱼儿啦啦啦
2017.03.07 18:20* 字数 3725

网上将自己的项目做成Pod 的文档很多,但是有些文档已经很老了,不适合新手上手,经过这两天的研究我决定还是自己写一篇这方面的文档:

整个过程的实现我以一个基于AFNetworking封装的网络请求OBDataService为例:

一、创建自己的github仓库

cocopods都托管在GitHub上(官方链接:https://github.com/CocoaPods),所有的Pods依赖库也都依赖github,因此第一步我们需要创建一个属于自己的github仓库。仓库创建界面如下图:


上图中标了序号的共6处,对应的说明如下:

1、Repository name

仓库名称,这里写成OBDataService,必填的.因为我之前创建过这个文件所以才会提示已经创建了;

2、Description

仓库的描述信息,可选的;

3、仓库的公开性

这里只能选Public,一个是因为Private是要money的,再一个Private别人看不到还共享个毛;

4、是否创建一个默认的README文件

一个完整地仓库,都需要README说明文档,建议选上。当然不嫌麻烦的话你也可以后面再手动创建一个;

5、是否添加.gitignore文件

.gitignore文件里面记录了若干中文件类型,凡是该文件包含的文件类型,git都不会将其纳入到版本管理中。是否选择看个人需要;

6、license类型

正规的仓库都应该有一个license文件,Pods依赖库对这个文件的要求更严,是必须要有的。因此最好在这里让github创建一个,也可以自己后续再创建。我使用的license类型是MIT。

上面的各项都填写完毕后,点击Create repository按钮即可,到这,仓库创建过程就结束了。

二、clone仓库到本地

为了便于向仓库中删减内容,需要先将仓库clone到本地,操作方式有多种,推荐使用命令行:

$ git clone https://github.com/obally/OBDataService.git

操作完成后,github上对应的文件都会拷贝到本地,目录结构为:

后续我们的所有文件增、删、改都在这个目录下进行。

2、LICENSE文件

CocoaPods强制要求所有的Pods依赖库都必须有license文件,否则验证不会通过。license的类型有很多种,详情可以参考网站tl;dr Legal。在创建github仓库的时候,我已经选择了MIT类型的license。

3、主类文件

创建Pods依赖库就是为了方便别人使用我们的成果,比如我想共享给大家的OBDataService类,是我想提供给广大用户使用的,这个类自然是必不可少的。我把这个类包含的两个文件放到一个名称为OBDataService的文件夹中,对应的目录结构如图:

里面包含两个文件:OBDataService.h和OBDataService.m


4、demo工程

为了快速地教会别人使用我们的Pods依赖库,通常需要提供一个demo工程。我创建的demo工程放到了一个名为OBDataServiceDemo的文件夹中,该目录包含的文件如下图所示:


我用pod 引入了AFNetworking

5、README.md

使用github的人应该都熟悉这个文件,它是一个成功github仓库必不可少的一部分,使用的是markdown标记语言,用于对仓库的详细说明。

以上所说的5个是创建Pods依赖库所需最基础的文件,其中1、2、3是必需的,4、5是可选但强烈推荐创建的。

添加完这些文件以后,我的github本地仓库目录就变成了下图所示的样子:


三、向本地git仓库中添加创建Pods依赖库所需文件

注意:以下描述的文件都要放在步骤二clone到本地的git仓库的根目录下面。

创建.podspec

首先在你的项目中使用如下命令创建名为 OBDataService 的 OBDataService.podspec(当然你也可以使用vim创建,只是没有默认文本而已)

$ pod spec create OBDataService

编辑.podspec

创建好的 .podspec 包含大量的注释说明了每个参数的含义及用法。如果想详细了解可以仔细阅读。这里只介绍几个常用的。

1、后缀为.podspec文件

该文件为Pods依赖库的描述文件,每个Pods依赖库必须有且仅有那么一个描述文件。文件名称要和我们想创建的依赖库名称保持一致,我的OBDataService依赖库对应的文件名为OBDataService.podspec。

1.1 podspec文件内容

OBDataService.podspec的保存内容为:

Pod::Spec.new do |s|

s.name        = "OBDataService"

s.version      = "1.0.0"

s.summary      = "A tool for URL Request"

s.description  = <<-DESC

A tool for URL Request base on AFNetworking

DESC

s.homepage    = "https://github.com/obally/OBDataService.git"

s.license      = "MIT"

s.author            = { "obally" => "*********@qq.com" }

s.platform    = :ios, "7.0"

s.source      = { :git => "https://github.com/obally/OBDataService.git", :tag => "#{s.version}" }

s.source_files  =  "OBDataService/*.{h,m}"

s.dependency "AFNetworking", "~> 3.1.0"

end

其中需要说明的又几个参数:

s.name:名称,pod search 搜索的关键词

s.version:版本

s.summary:简介,pod search 搜索的关键词

s.homepage:主页地址,例如Github地址

s.license:许可证

s.author:作者

s.social_media_url:社交网址

s.platform:平台

s.source:Git仓库地址,例如在Github地址后边加上 .git 就是Git仓库地址,常见写法如下

s.source_files:需要包含的源文件,常见的写法如下

s.resources:需要包含的图片等资源文件

s.dependency:依赖库,不能依赖未发布的库

s.dependency:依赖库,如有多个可以这样写

s.requires_arc:是否要求ARC

s.source_files 常见写法


"Directory1/*"  表示匹配所有文件

"Directory1/Directory2/*.{h,m}"  表示匹配所有以.h和.m结尾的文件

"Directory1/**/*.h"  表示匹配所有子目录


s.source 常见写法


s.source = { :git => "https://github.com/obally/OBDataService.git", :commit => "68defea" }

s.source = { :git => "https://github.com//obally/OBDataService.git", :tag => 1.0.0 }

s.source = { :git => "https://github.com//obally/OBDataService.git", :tag => s.version }


commit => "68defea" 表示将这个Pod版本与Git仓库中某个commit绑定

tag => 1.0.0 表示将这个Pod版本与Git仓库中某个版本的comit绑定

tag => s.version 表示将这个Pod版本与Git仓库中相同版本的comit绑定

按照上述规则编辑完成就制作好了 .podspec(最好使用vim进行编辑)。

验证.podspec

执行以下命令,为 Pod 添加版本号,并打上 tag:

set the new version to 1.0.0

set the new tag to 1.0.0

编辑好后最好先验证 .podspec 是否有有效

$ pod spec lint

验证过程中:

-> OBDataService

验证成功后:OBDataService.podspec passed validation.

验证失败后:[!] The spec did not pass validation, due to 1 error.

验证 .podspec 会先测试本地 .podspec 文件是否存在语法错误。测试成功再根据 .podspec 文件找到远端仓库对应的版本克隆到本地并进行配置。最后测试文件是否能够编译成功。

.podspec验证失败错误排查

语法错误

如果是因为语法错误,验证失败后会给出错误的准确定位

[!] Invalid `OBDataService.podspec` file: no .floating literal anymore; put 0 before dot

s.version = “1.0.0”

^

OBDataService.podspec:5: syntax error, unexpected tFLOAT, expecting '('

s.version = “1.0.0”

^

标记“^”的地方即为有语法错误的地方。

上述错误是因为使用“文本编辑”进行编辑造成的。使用文本编辑有时候英文""引号会自动变成中文“”引号。

[!] Your Podfile has had smart quotes sanitised. To avoid issues in the future, you should not use TextEdit for editing it. If you are not using TextEdit, you should turn off smart quotes in your editor of choice.

使用 vim 将其改为英文的""引号即可。

依赖错误

但是,有些非语法错误是不会给出错误原因的。这个时候可以使用“--verbose”来查看详细的验证过程来帮助定位错误。

pod spec lint OBDataService.podspec --verbose

如下错误通过 --verbose 就可以找到原因。

-> OBDataService(1.0.0)

- ERROR | [iOS] Encountered an unknown error (The 'Pods' target has transitive dependencies that include static binaries: (/private/var/folders/jz/b_m3k7ln47524cm__h3__mk00000gn/T/CocoaPods/Lint/Pods/BPushSDK/LibBPush/libBPush.a)) during validation.

这个错误是因为依赖库(s.dependency)包含了.a静态库造成的。虽然这并不影响Pod的使用,但是验证是无法通过的。可以通过 --use-libraries 来让验证通过。

pod spec lint OBDataService.podspec --verbose --use-libraries

这种情况下使用 --use-libraries 虽然不会出现错误(error),但是有时候会带来一些警告(waring),警告同样是无法通过验证的。这时可以用 --allow-warnings 来允许警告。

pod spec lint OBDataService.podspec --verbose --use-libraries --allow-warnings

安装错误

如果在其他项目 pod install 的过程中,出现包含“undefined method end_with?' for nil”字样的报错。进入“~/.cocoapods/repos”目录,删除“master”,并将 master-1 改为 master 即可。

如果出现如下错误,而你的验证可以通过,那么一般更新下版本号就可以解决。[!] Unable to find a specification for 'OBDataService'.`

再次验证

如果错误发生在 .podspec 中。当修改完时,不需要再次提交就可以直接验证。如果错误发生在代码中,则需要再次提交才能验证。

上传到Git

将包含配置好的 .podspec 的项目提交 Git,并给这次提交打上 tag


$ git add -A && git commit -m "Release 1.0.0."

$ git tag '1.0.0'

$ git push --tags

$ git push origin master



发布到CocoaPods

你可以用 .podspec 文件来方便的管理内部代码,当然,也可以发布自己的 Pod 供其他开发者使用。

CocoaPods 0.33中加入了 Trunk 服务,使用 Trunk 服务可以方便的发布自己的Pod。虽然一开始使用 GitHub Pull Requests 来整理所有公共 pods 效果很好。但是,随着 Pod 数量的增加,这个工作对于 spec 维护人员 Keith Smiley 来说变得十分繁杂。甚至一些没有通过 $ pod lint 的 spec 也被提交上来,造成 repo 无法 build。CocoaPods Trunk 服务的引入,解决了很多类似的问题。每次使用 Trunk 服务发布 Pod 时都会通过 $ pod lint 验证 .podspec 是否有效。要想使用 Trunk 服务,首先需要使用如下命令注册自己的电脑。这很简单,只要你指明你的邮箱地址(spec文件中的)和名称即可。CocoaPods 会给你填写的邮箱发送验证邮件,点击邮件中的链接就可通过验证。

pod trunk register *********@qq.com "obally"

然后就可以发布你的 Pod 了。

pod trunk push OBDataService.podspec

发布时会验证 Pod 的有效性,如果你在手动验证 Pod 时使用了 --use-libraries 或 --allow-warnings 等修饰符,那么发布的时候也应该使用相同的字段修饰,否则出现相同的报错。

pod trunk push OBDataService.podspec --use-libraries --allow-warnings

发布成功后,就可以使用 pod search 搜索到你的 Pod 了!

由于 pod search 是搜索的本地“~/.cocoapods”,所以在其他设备上可能无法搜到。这时只需要执行 pod install 更新下 pod 仓库即可(不要加 --no-repo-update)。

版本升级

当需要更新 Pod 版本的时候,修改 .podspec 中的 s.version 为更高的版本号,并修改 s.source 中对应的 Git 版本。提交到Git,并打上对应tag。然后再次执行pod trunk push HTQRCode.podspec.当修改了项目内容,重新提交,修改tag,一定要记得修改.podspec 中的s.version 

将新的 .podspec 发布到 CocoaPods。更新完成!

为了更新更加方便,版本控制更加清晰,s.source 建议采用如下写法:

s.source = { :git => "https://github.com/obally/OBDataService.git", :tag => s.version }

这样写将 Git 的版本与 CocoaPods 的版本进行了绑定。每次提交后再给本次提交打上 tag 就完成了更新。而且在 Git 中就可以清晰的看到哪次提交对应的哪个 CocoaPods 版本。如果与 commit 绑定,则要通过两次提交才能完成更新,第一次先提交修改代码,第二次将上一次 commit id 更新到 s.source 然后再次提交。如果直接与固定 tag 绑定,则每次还都要修改 s.source。如果你的 Pod 是私有库,那么 s.source 其实是无用的。因为在 Podfile 中已经指明了地址和版本(如下)。这时 s.source 可以随便填写,但最好还是按照上述规则以便以后发布。

协同工作

当需要其他人来共同维护你的代码,需要提供权限

pod trunk add-owner OBDataService *******@163.com


总结制作pod的步骤

1.从自己的github上创建项目,clone到本地

git clone https://github.com/obally/OBDataService.git

2.创建创建podspec文件和相对应的项目

Pod::Spec.new do |s|

s.name        = "OBDataService"

s.version      = "1.0.2"

s.summary      = "A tool for URL Request"

s.description  = <<-DESC

A tool for URL Request base on AFNetworking

DESC

s.homepage    = "https://github.com/obally/OBDataService.git"

s.license      = "MIT"

s.author            = { "obally" => "*********@qq.com" }

s.platform    = :ios, "7.0"

s.source      = { :git => "https://github.com/obally/OBDataService.git", :tag => "#{s.version}" }

s.source_files  =  "OBDataService/*.{h,m}"

s.dependency "AFNetworking", "~> 3.1.0"

end

3.推送的远程仓库,校验podspec文件

git add -A && git commit -m "Release 1.0.0."

git tag '1.0.0'

git push --tags

git push origin master

pod spec lint

4.使用trunk发布到CocoaPods(第一次需要register)

pod trunk register *********@qq.com "obally"

pod trunk push OBDataService.podspec

5.如需更改项目或者.podspec 文件 修改2中s.version 重复3步骤还有4中的第二步骤即可,记住s.version 必须与3中的tag 保持一致

日记本
Web note ad 1